/* This file is part of Indico.
 * Copyright (C) 2002 - 2015 European Organization for Nuclear Research (CERN).
 *
 * Indico is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Indico is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Indico; if not, see <http://www.gnu.org/licenses/>.
 */

@import 'base/palette';
@import 'base/defaults';
@import 'base/utilities';
@import 'compass';
@import 'compass/css3/user-interface';

%attachment-line {
    line-height: 1rem;

    vertical-align: middle;
}

%attachment-icon {
    @extend %attachment-line;

    font-size: 0.8rem;

    width: 1px;

    white-space: nowrap;
}

@mixin colored-icon($color) {
    &:before {
        color: $color;
    }
    &:hover:not(.disabled):not(disabled):before {
        color: lighten($color, $light-color-variation) !important;
    }
}

.attachment-editor {
    width: 800px;
}

.dialog-window .attachments-container {
    max-height: 50vh;
    overflow-y: auto;
}

.tree {
    width: 100%;

    border-collapse: collapse;
    tr {
        > td {
            font-size: 0.9rem;

            padding: 0.2rem 0.3rem;
            &:first-child {
                @include icon-before('icon-none');

                overflow: hidden;

                max-width: 1px;

                white-space: nowrap;
                text-overflow: ellipsis;
                &:before {
                    display: inline-block;

                }
                > .custom-protection:before {
                    @extend %attachment-icon;

                    color: $pastel-red;
                }
                > a.icon-file-pdf {
                    @include colored-icon($red);
                }

                > a.icon-file-excel {
                    @include colored-icon($green);
                }

                > a.icon-file-word {
                    @include colored-icon($dark-blue);
                }

                > a.icon-file-image {
                    @include colored-icon($blue);
                }

                > a.icon-calendar {
                    @include colored-icon($dark-yellow);
                }

                > a.icon-file-presentation {
                    @include colored-icon($yellow);
                }
            }
            > * {
                @extend %attachment-line;
            }
        }
        &:not(.sub-tree) {
            > td {
                &:first-child:before, > a, > span {
                    color: $light-black;
                }
                > a {
                    &:hover {
                        color: $black;
                    }

                    &:before {
                        margin-right: 0.5em;
                    }
                }
                &.actions,
                &.actions > *,
                &.date {
                    @extend %attachment-icon;

                    color: $gray;
                }
                &.actions {
                    width: 2.2rem;

                    text-align: right;
                    > * {
                        visibility: hidden;

                        cursor: pointer;

                        opacity: 0;
                        &.icon-remove:hover:before {
                            color: $red;
                        }
                        &.icon-edit:hover:before,
                        &.icon-file-download:hover:before {
                            color: $blue;
                        }
                    }
                }
            }
            &:hover:not(.empty) > td {
                background-color: $pastel-blue;
                &:first-child {
                    @include border-top-left-radius(2px);
                    @include border-bottom-left-radius(2px);
                }
                &:last-child {
                    @include border-top-right-radius(2px);
                    @include border-bottom-right-radius(2px);
                }
                &.actions > *,
                &.date {
                    color: $dark-gray;
                }
                &.actions > * {
                    visibility: visible;

                    opacity: 1;
                }
            }
        }
        &.expandable {
            @include user-select(none);

            cursor: pointer;
            > td {
                &:first-child {
                    @include icon-before('icon-arrow-down');
                    @include border-top-left-radius(2px);
                    @include border-bottom-left-radius(2px);

                    font-weight: bold;
                    &:before {
                        @include transition(transform 0.15s ease-out);

                        -webkit-transform-origin: 50%  51%; // improve blurry text on rotate with chrome
                    }
                    > span {
                        &:before {
                            margin-right: 0.25em;
                        }

                        @include icon-before('icon-folder-open');
                    }
                }
                &:last-child {
                    @include border-top-right-radius(2px);
                }
            }
            &.collapsed > td:first-child {
                > span {
                    @include icon-before('icon-folder');
                }
                &:before {
                    @include rotate(-90deg);
                }
            }
        }
        &.sub-tree > td {
            padding: 0 0 0 2.8em;
            &:first-child:before {
                display: none; // no icon space for nested files
            }
            > div > .tree {
                @include border-radius(2px);

                background-color: $light-gray;
                tr > td:first-child:before {
                    display: none; // no icon space for nested files
                }
            }
        }
        &.empty > td {
            font-style: italic;

            color: $dark-gray;
        }
    }
}

%protected-colors {
    border-bottom: 2px solid $red;
    &:hover:before {
        color: $red !important;
    }
    &:hover {
        border-bottom-color: $red !important;
    }
}

.attachment.icon-file-pdf {
    @include colored-icon($red);
}

.attachment.icon-file-excel {
    @include colored-icon($green);
}

.attachment.icon-file-word {
    @include colored-icon($dark-blue);
}

.attachment.icon-file-image {
    @include colored-icon($blue);
}

.attachment.icon-calendar {
    @include colored-icon($dark-yellow);
}

.attachment.icon-file-presentation {
    @include colored-icon($yellow);
}

.attachments-box {
    padding: 5px;

    background-color: $light-gray;
    > .attachments-box-header {
        > * {
            color: $dark-gray;
            display: inline-block;

            vertical-align: middle;
        }
        > h2 {
            &:before {
                margin-right: 0.2em;
            }
            margin: 0 0 0.25em 0;
        }
        > .i-button.right {
            margin-top: 0;
        }

        margin-bottom: 0.5em;
    }
    .tree tr.sub-tree > td > div > .tree {
        background-color: white;
    }
}

.category-sidebar > .attachments-box > .attachments-box-header {
    margin-top: 20px;
    padding-bottom: 0.2em;

    border-bottom: 1px solid #ebebeb;
    box-shadow: 0 1px 0 #fafafa;
    > h2 {
        padding-bottom: 0;

        border-bottom: 0;
        box-shadow: none;
    }
}

.contribution-display .row.files .column .attachments-box > .attachments-box-header {
    > h2 {
        margin-top: 0;
        padding-bottom: 0;
        border-bottom: 0;
    }
    > .i-button.right {
        margin: 0 !important;
    }
    padding-bottom: 0.5em;
    border-bottom: 1px solid darken($light-gray, 10%);
}

.inline-attachments-icon {
    vertical-align: middle !important;
    text-align: right;
    line-height: 1.7em;
    &:before {
        display: inline-block;
        margin-top: 0.3em;
        font-size: 1.4em;
        color: $dark-gray;
    }
}

.material-list {
    .folder .attachment {
        display: inline-block;
        overflow: hidden;

        max-width: 100px;
        padding-left: 0.2em !important;

        text-overflow: ellipsis;
        .title {
            color: $light-black;
            font-size: 0.9em;
            text-overflow: ellipsis;
            white-space: nowrap;
        }
    }
    .folder .i-button.attachment,
    .folder .attachments {
        display: inline-block;
        font-family: Roboto;
        font-weight: normal;

        display: inline-block;
        white-space: nowrap;

        margin-top: 0.2em;
        &:not(first-child) {
            margin-left: 0.2em;
        }
        &.is-protected {
            @extend %protected-colors;
        }
        &.has-label {
            margin: 0;
            padding-left: 0.7em !important;
        }
    }
    .folder.toolbar {
        display: inline-block;

        &.is-protected {
            .i-button.label {
                @extend %protected-colors;

                border-bottom-color: $red !important;
            }
        }
    }
    .folder .dropdown {
        & > li {
            padding: 0.1em 0.2em !important;

            .attachment {
                max-width: 250px;
                &.is-protected {
                    color: $red;
                }
            }
        }
    }
}

.folder-main, div.main > .attachments-package {
    max-width: 1024px;
    margin: auto;
    margin-top: 2em;
    padding: 2em;
    background-color: $light-gray;
}

.attachment-preview-top-bar {
    position: fixed;
    top: 0;
    left: 0;
    height: 30px;
    width: 100%;
    background-color: $black;
    color: white;
    padding: 10px 0 10px 0;
    z-index: 10;

    .attachment-title {
        left: 20px;
        position: absolute;
        white-space: nowrap;

        > span {
            font-size: 1.1em;
            line-height: 30px;

            &:before {
                margin-right: 0.5em;
            }
        }
    }

    .attachment-preview-close {
        right: 20px;
        position: absolute;

        > a {
            font-size: 1.5em;
            line-height: 30px;
            color: white;
            vertical-align: middle;
        }
    }

    .attachment-actions {
        right: 50px;
        position: absolute;

        > a {
            font-size: 1.3em;
        }

        > .attachment-download {
            color: white;
        }
    }
}

.attachment-preview-dialog {
    .exclusivePopup {
        padding: 0;
        position: fixed;
        width: 100%;
        height: 100%;
        left: 0;
        top: 0;
        background-color: transparent;

        .attachment-preview-content-wrapper {
            height: auto;
            width: 100%;
            position: absolute;
            top: 50px;
            bottom: 0;

            .attachment-preview-content {
                > img {
                    position: absolute;
                    margin: auto;
                    top: 0;
                    left: 0;
                    right: 0;
                    bottom: 0;
                    max-width: 90%;
                    max-height: 80%;
                }

                > iframe, .text-preview-content {
                    position: absolute;
                    margin: auto;
                    left: 0;
                    right: 0;
                    height: 100%;
                    width: 900px;
                }

                > .text-preview-content {
                    padding: 2vw;
                    background-color: white;
                    overflow: auto;
                    box-sizing: border-box;
                }
            }
        }
    }
}

.attachment-preview-overlay {
    opacity: 0.9;
}

.attachments-tooltip-button {
    @include icon-before('icon-folder');
    cursor: pointer;
    color: $gray;

    &:hover, &.open {
        color: $dark-gray;
    }

    &.open {
        @include icon-before('icon-folder-open');
    }
}
